#include <LEDA/graphics/graphwin.h>
#include <LEDA/graph/node_array.h>
#include <LEDA/graph/graph_alg.h>
#include <LEDA/graph/node_pq.h>
#include <LEDA/graph/graph.h>
#include <LEDA/core/string.h>
#include <LEDA/core/array.h>
#include <LEDA/system/stream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

#include<stdlib.h>
#include<iostream>
#include<fstream>



#define SIZE 1000
#define N 56
#define S 0.85

using namespace leda;
using std::ifstream;
using std::cin;
using std::cout;
using std::endl;

void input(double dis[SIZE][SIZE], double s_d[N][N], char hougen_name[N][N], double *min_dis, double *max_dis);
void random_tree(graph& G,int n,node leaf[],node in_n[],edge e[]);
void copy_G(const graph& d_G,graph& G,int n,const node d_leaf[SIZE],node leaf[SIZE],const node d_in_n[SIZE],node in_n[SIZE],const edge d_e[SIZE],edge e[SIZE]);
double GC(graph& G,int n,double dis[SIZE][SIZE]); //Gのコストを求める
double cost(double dis[SIZE][SIZE],int n, int flag);//部分木のコスト flag=0:min flag=1:max
double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d);//quartetのコスト
void create_node(graph& G, node leaf[], int val);
bool search_node(graph& G, node in_n[], int n, int *val1, int val2, int num, int flag);
edge link_node(graph& G, node in_n[], node leaf[], int n, int *a, int *b, int flag);
void leaf_swap(graph& G,int n,node leaf[],node in_n[],edge e[]);
void subtree_swap(graph& G,int n,node in_n[SIZE],edge e[SIZE]);
void trancefer(graph& G,int n,edge e[SIZE]);
void tree_out(graph& G, array<string> l_name, node laef[]);

int main(){

	double dis[SIZE][SIZE]={0},s_d[N][N]={0},q_cost[3]={0},ST[3]={0};
	double G_ST,G_cost,min,max,max_ST;
	char hougen_name[N][N]={0};
	double min_dis=1, max_dis=0;
	int i,cnt=0;

	input(dis,s_d,hougen_name,&min_dis,&max_dis);/*入力関数*/
	
	GRAPH<char,double> G,d_G,d1_G,d2_G;
	node leaf[N],d_leaf[N],d1_leaf[N],d2_leaf[N]; //dataをいれるnode型の配列
 	node in_n[N-2],d_in_n[N-2],d1_in_n[N-2],d2_in_n[N-2]; //inner nodeをいれるnode型の配列
	edge e[2*N-3],d_e[2*N-3],d1_e[2*N-3],d2_e[2*N-3];

	srand((unsigned)time(NULL)); /*乱数初期化*/
	random_tree(G,N,leaf,in_n,e);/*random_treeの生成*/
	G.make_undirected();
	
	copy_G(G,d_G,N,leaf,d_leaf,in_n,d_in_n,e,d_e);//leaf_swap用
  	copy_G(G,d1_G,N,leaf,d1_leaf,in_n,d1_in_n,e,d1_e);//subtree_swap用
  	copy_G(G,d2_G,N,leaf,d2_leaf,in_n,d2_in_n,e,d2_e);//trancefer用

	min=cost(dis,N,0); //Gの最小コスト
	max=cost(dis,N,1); //Gの最大コスト
	G_cost=GC(G,N,dis); //Gのコスト
	G_ST=((G_cost-max) / (min-max)); //GのST値を求める
	max_ST=G_ST;
	cout << "G_ST = " << G_ST << endl << endl;
	
	do{
		leaf_swap(d_G,N,d_leaf,d_in_n,d_e);
     		q_cost[0]=GC(d_G,N,dis);
     		ST[0]=(q_cost[0]-max) / (min-max);
		cout << "ST[0] = " << ST[0] << endl;
     		     
     		subtree_swap(d1_G,N,d1_in_n,d1_e);
     		q_cost[1]=GC(d1_G,N,dis);
     		ST[1]=(q_cost[1]-max) / (min-max);
		cout << "ST[1] = " << ST[1] << endl;
     		
     		trancefer(d2_G,N,d2_e);
     		q_cost[2]=GC(d2_G,N,dis);
     		ST[2]=(q_cost[2]-max) / (min-max);
		cout << "ST[2] = " << ST[2] << endl;
     			
		for(i=0;i < 3;i++){
			if(max_ST <= ST[i]) max_ST=ST[i];
		}

		cout << "max_ST = "<< max_ST << endl << endl;
		
		if(max_ST==ST[0])	copy_G(d_G,G,N,d_leaf,leaf,d_in_n,in_n,d_e,e);
      		else if(max_ST==ST[1])	copy_G(d1_G,G,N,d1_leaf,leaf,d1_in_n,in_n,d1_e,e);
      		else if(max_ST==ST[2])	copy_G(d2_G,G,N,d2_leaf,leaf,d2_in_n,in_n,d2_e,e);
    		else{
      			copy_G(G,d_G,N,leaf,d_leaf,in_n,d_in_n,e,d_e);
      			copy_G(G,d1_G,N,leaf,d1_leaf,in_n,d1_in_n,e,d1_e);
      			copy_G(G,d2_G,N,leaf,d2_leaf,in_n,d2_in_n,e,d2_e);
    		}
		cnt++;
	}while(max_ST<S);
	
	cout << "操作回数 = "<< cnt << endl;  
	array<string> l_name(N);
	tree_out(G,l_name,leaf);//グラフの表示
	
	return 0;
}

void input(double dis[SIZE][SIZE], double s_d[N][N], char hougen_name[N][N], double *min_dis, double *max_dis){

	int i,j;

	ifstream fin("fileout");

	for(i=0;i<N;i++){
    		for(j=0;j<N;j++){
      			if(i==j){
				dis[i][j]=0;
        			//cout << dis[i][j] <<' ';
     			}else{
       			fin>>hougen_name[0];
				fin>>dis[i][j];
       			s_d[i][j]=dis[i][j];
       			if(dis[i][j] < *min_dis)	*min_dis = dis[i][j];
       			else if(dis[i][j] > *max_dis)	*max_dis = dis[i][j];
       			//cout << dis[i][j] <<' ';
      			}
    		}
    		//putchar('\n');
  	}
}

void random_tree(graph& G,int n,node leaf[],node in_n[],edge e[]){
  
  	int i,j,m;
  	int deg,ed;
  	int a,b,c;
	
	for(i=0;i<n;i++)	leaf[i]=G.new_node(); //グラフG内にnodeを作る
  	for(i=0;i<n-2;i++)	in_n[i]=G.new_node(); //グラフG内にinner_nodeを作る
		
  	for(j=0;j<n/2;j++){ //subtreeを作る
    		while(true){
			a=rand()%n;
      		b=rand()%n;
      		c=rand()%(n-2);
      		if(a!=b){//葉が同一のものでなく、全てのnodeの次数が0のとき抜けることができる
				if(G.degree(leaf[a])==0 && G.degree(leaf[b])==0 && G.degree(in_n[c])==0) break;
      			}
    		}
    		m=n/2;
    		e[j]=G.new_edge(in_n[c],leaf[a]);
    		e[j+m]=G.new_edge(in_n[c],leaf[b]);
    		ed=j+m+1;
  	}

  	do{
    		m=0;
    		if(n<=4) break;

    		while(search_node(G,in_n,n,&a,0,0,0)); //次数0のinner nodeを探す
      		while(search_node(G,in_n,n,&b,0,2,0)); //次数2のinner nodeを探す
      		while(search_node(G,in_n,n,&c,b,2,1)); //次数2のinner nodeを探す
    
  		e[ed]=G.new_edge(in_n[a],in_n[b]);
    		e[ed+1]=G.new_edge(in_n[a],in_n[c]);
    		ed=ed+2;

    		for(j=0;j<n-2;j++){ //次数が0のinner nodeがあるかどうかを判定
      			deg=G.degree(in_n[j]);
      			if(deg==0)	m=1;
      		}
  	}while(m==1); //次数が0のinner nodeがある限り続ける
 
  	if(n%2==0)	e[ed]=link_node(G,in_n,leaf,n,&a,&b,0); //葉の数が偶数ならば、次数2のinner node同士を結ぶ
    	else	e[ed]=link_node(G,in_n,leaf,n,&a,&b,1); //葉の数が奇数ならば、次数0の葉と次数2のinner nodeを結ぶ
}

bool search_node(graph& G, node in_n[], int n, int *val1, int val2, int num, int flag){
	
	*val1=rand()%(n-2);

	if(flag==0){
		if(G.degree(in_n[*val1])==num)	return false;
	}else{
		if(G.degree(in_n[*val1])==num && *val1 != val2)	return false;
	}
	return true;
}

edge link_node(graph& G, node in_n[], node leaf[], int n, int *a, int *b, int flag){
	
	int i;

	if(flag==0){
		for(i=0;i<n-2;i++){
      			if(G.degree(in_n[i])==2){
				*a=i;
				break;
      			}	
   		}
   		for(i=*a+1;i<n-2;i++){
      			if(G.degree(in_n[i])==2){
				*b=i;
				break;
      			}
    		}
		return (G.new_edge(in_n[*a],in_n[*b]));
	}else{
		for(i=0;i<n;i++){
      			if(G.degree(leaf[i])==0){
				*a=i;
				break;
      			}
    		}
    		for(i=0;i<n-2;i++){
      			if(G.degree(in_n[i])==2){
				*b=i;
				break;
      			}
    		}
		return (G.new_edge(in_n[*b],leaf[*a]));
	}
}

void copy_G(const graph& d_G,graph& G,int n,const node d_leaf[SIZE],node leaf[SIZE],const node d_in_n[SIZE],node in_n[SIZE],const edge d_e[SIZE],edge e[SIZE]){

	node w;  	
	edge eg;
	G=d_G;

  	forall_nodes(w,G){
    		if(index(w)<n)	leaf[index(w)]=w;
    		else	in_n[index(w)-n]=w;
      	}
  	forall_edges(eg,G)  e[index(eg)]=eg;
}

double cost(double dis[SIZE][SIZE],int n, int flag){

	int i,j,k,l;
  	double min=0,max=0,tmp;

  	for(i=0;i<n-3;i++){
    		for(j=i+1;j<n-2;j++){
      			for(k=j+1;k<n-1;k++){
				for(l=k+1;l<n;l++){
	  				tmp=dis[i][j]+dis[k][l];
					if(flag==0){
	  					if(tmp>dis[i][k]+dis[j][l])	tmp=dis[i][k]+dis[j][l];
	  					if(tmp>dis[i][l]+dis[j][k])	tmp=dis[i][l]+dis[j][k];
	  					min=min+tmp;
					}else{
						if(tmp<dis[i][k]+dis[j][l])	tmp=dis[i][k]+dis[j][l];
	  					if(tmp<dis[i][l]+dis[j][k])	tmp=dis[i][l]+dis[j][k];
	  					max=max+tmp;
					}
				}
      			}
    		}
  	}

	if(flag==0)	return (min);
  	else	return (max);
}

double GC(graph& G,int n,double dis[SIZE][SIZE]){
	
  	int a,b,c,d;
  	double cost=0;

  	for(a=0;a<n-3;a++)
    		for(b=a+1;b<n-2;b++)
      			for(c=b+1;c<n-1;c++)
				for(d=c+1;d<n;d++)	cost=cost+quartet_cost(G,n,dis,a,b,c,d);
	return (cost);
}

double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d){
	
	int a_to[SIZE]={0};
  	int d_to[SIZE]={0};
  	int i=0,j=0;
  	int x=0,y=0;
  	double q_cost;

  	edge_array<int> cost(G,1);
  	node_array<int> dist_a(G,MAXINT);
  	node_array<int> dist_d(G,MAXINT);
  	node_array<edge> pred_a(G);
  	node_array<edge> pred_d(G);

  	node v,na,nb,nc,nd;

  	forall_nodes(v,G){
    		if(index(v)==a) na=v;
    		else if(index(v)==b)	nb=v;
    		else if(index(v)==c)	nc=v;
    		else if(index(v)==d)	nd=v;
    	}

  	DIJKSTRA(G,na,cost,dist_a,pred_a);
  	DIJKSTRA(G,nd,cost,dist_d,pred_d);
  
  	edge e;
  	node u,w;
  
  	/**************Check quartet (ab|cd)***************/
  
  	forall_nodes(w,G){
    		if(w==nb){
      			u=w;
      			while(e=pred_a[u]){
				if(u==G.source(e))	u=G.target(e);
				else	u=G.source(e);
				a_to[i]=index(u);
				i++;
      			}
    		}else if(w==nc){
      			u=w;
     			while(e=pred_d[u]){
				if(u==G.source(e))	u=G.target(e);
				else	u=G.source(e);
				d_to[j]=index(u);
				j++;
      			}
    		}
  	}
  
  	for(i=0;i<dist_a[nb];i++){
    		for(j=0;j<dist_d[nc];j++){
      			if(a_to[i]==d_to[j]){
				x=1;
				break;
      			}
    		}
    		if(x)	break;
  	}

  	/**************Check quartet (ab|cd)***************/
  	i=0;
  	j=0;
  	/**************Check quartet (ac|bd)***************/

  	forall_nodes(w,G){
    		if(w==nc){
      			u=w;
      			while(e=pred_a[u]){
				if(u==G.source(e))	u=G.target(e);
				else	u=G.source(e);
				a_to[i]=index(u);
				i++;
      			}
    		}else if(w==nb){
      			u=w;
     			while(e=pred_d[u]){
				if(u==G.source(e))	u=G.target(e);
				else	u=G.source(e);
				d_to[j]=index(u);
				j++;
      			}
    		}	
 	}

 	for(i=0;i<dist_a[nc];i++){
    		for(j=0;j<dist_d[nb];j++){
      			if(a_to[i]==d_to[j]){
			y=1;
			break;
      			}
   		}
    		if(y)	break;
  	}

  	/**************Check quartet (ac|bd)***************/

 	if(x==1 && y==1)	q_cost=dis[a][d]+dis[b][c];
  	else if(x==0)	q_cost=dis[a][b]+dis[c][d];
  	else if(y==0)	q_cost=dis[a][c]+dis[b][d];
  	else	cout << "Error!!" << endl;
  	
  	return(q_cost);
}

void leaf_swap(graph& G,int n,node leaf[],node in_n[],edge e[]){
   
  	int a,b;

  	a=rand()%n; //交換する葉を二つ選ぶ
  	do{
    		b=rand()%n;
  	}while(a==b);
	
  	node v,u;
	edge eg_a,eg_b;
	
	eg_a=G.first_adj_edge(leaf[a]);
	u=G.opposite(leaf[a],eg_a);
	eg_b=G.first_adj_edge(leaf[b]);
	v=G.opposite(leaf[b],eg_b);
		
	G.del_edge(eg_a);
  	G.del_edge(eg_b);
	
	e[index(eg_a)]=G.new_edge(v,leaf[a]);
  	e[index(eg_b)]=G.new_edge(u,leaf[b]);

}

void subtree_swap(graph& G,int n,node in_n[],edge e[]){
  
  	int a,b;

  	a=rand()%(n-2); //交換するinner nodeを選ぶ
  	do{
    		b=rand()%(n-2);
  	}while(a==b);

  	edge_array<int> cost(G,1);
  	node_array<int> dist(G,MAXINT);
  	node_array<edge> pred(G);

  	DIJKSTRA(G,in_n[a],cost,dist,pred);

  	node v,u;
  	edge eg,eg_a,eg_b;
  	forall_nodes(v,G){
    		if(v==in_n[b]){
      			eg_b=pred[v];
      			u=v;
      			while(eg=pred[u]){
				if(u==G.source(eg))		u=G.target(eg);
				else	u=G.source(eg);
				eg_a=eg;
      			}
    		}
  	}

  	if(dist[in_n[b]]>2){
		node ch_na,ch_nb;
    		if(in_n[a]==source(eg_a))	ch_na=target(eg_a);
    		else	ch_na=source(eg_a);
    		   
    		if(in_n[b]==source(eg_b))	ch_nb=target(eg_b);
    		else	ch_nb=source(eg_b);
    		    
    		G.del_edge(eg_a);
    		G.del_edge(eg_b);
    
    		e[index(eg_a)]=G.new_edge(ch_nb,in_n[a]);
    		e[index(eg_b)]=G.new_edge(ch_na,in_n[b]);
  	}	
}

void trancefer(graph& G,int n,edge e[SIZE]){
 
  	int a,b;

  	a=rand()%(2*n-2);
  	do{
    		b=rand()%(2*n-2);
  	}while(a==b || (a<n && b<n));
  
  	edge_array<int> cost(G,1);
 	node_array<int> dist(G,MAXINT);
  	node_array<edge> pred(G);
  
  	node na,nb,nd;
  
  	forall_nodes(nd,G){
    		if(index(nd)==a)	na=nd;
    		else if(index(nd)==b)	nb=nd;
    	}

  	DIJKSTRA(G,na,cost,dist,pred);

  	node v,u;
  	edge eg;
  	edge eg_a,eg_b;

  	forall_nodes(v,G){
    		if(v==nb){
      			eg_b=pred[v];
      			u=v;
      			while(eg=pred[u]){
				if(u==G.source(eg))		u=G.target(eg);
				else	u=G.source(eg);
				eg_a=eg;
      			}
    		}
  	}


  	if(dist[nb]>2){
    		node a_adj;
    		if(na==source(eg_a))	a_adj=target(eg_a);
    		else	a_adj=source(eg_a);
    		
    		G.del_edge(eg_a);

    		edge adj_1,adj_2;
    		adj_1=G.first_adj_edge(a_adj);
    		adj_2=G.last_adj_edge(a_adj);
  
    		G.del_edge(adj_1);
    		G.del_edge(adj_2);

    		if(a_adj==source(adj_1)){
      			if(a_adj==source(adj_2))	e[index(adj_2)]=G.new_edge(target(adj_1),target(adj_2));
      			else	e[index(adj_2)]=G.new_edge(target(adj_1),source(adj_2));
      		}else{
      			if(a_adj==source(adj_2))	e[index(adj_2)]=G.new_edge(source(adj_1),target(adj_2));
      			else	e[index(adj_2)]=G.new_edge(source(adj_1),source(adj_2));
     		}

    		node b_adj;
    		if(nb==source(eg_b))	b_adj=target(eg_b);
    		else	b_adj=source(eg_b);
    		
    		G.del_edge(eg_b);
    		e[index(eg_a)]=G.new_edge(a_adj,b_adj);
    		e[index(eg_b)]=G.new_edge(a_adj,na); 
    		e[index(adj_1)]=G.new_edge(a_adj,nb);
   	}
}

void tree_out(graph& G, array<string> hougen_name, node leaf[]){

	int i;
      
	GraphWin gw(G,800,800,"quartet-method");
	gw.set_node_color(red);
  	gw.set_edge_direction(undirected_edge);
	gw.set_graph(G);

	ifstream fin("filename");

	for(i=0;i<N;i++){
		fin >> hougen_name[i];
		gw.set_label(leaf[i],hougen_name[i]);  
		gw.set_shape(leaf[i],rectangle_node);

   //***************地域によっての色分け*****************

    if(strcmp(hougen_name[i],"hokkai1")==0 || strcmp(hougen_name[i],"hokkai2")==0)
      gw.set_color(leaf[i],black);
    else if(strcmp(hougen_name[i],"aomori")==0 || strcmp(hougen_name[i],"iwate1") ==0 || strcmp(hougen_name[i],"iwate2")==0 || strcmp(hougen_name[i],"akita")==0 || strcmp(hougen_name[i],"miyagi")==0 || strcmp(hougen_name[i],"fukushima")==0 || strcmp(hougen_name[i],"yamagata")==0 )
      gw.set_color(leaf[i],green);
    else if(strcmp(hougen_name[i],"totigi")==0 || strcmp(hougen_name[i],"gunma")==0 || strcmp(hougen_name[i],"ibaraki")==0 || strcmp(hougen_name[i],"chiba1")==0 || strcmp(hougen_name[i],"chiba2")==0 || strcmp(hougen_name[i],"tokyo1")==0 || strcmp(hougen_name[i],"kanagawa")==0 || strcmp(hougen_name[i],"nhk")==0)
      gw.set_color(leaf[i],blue);
    else if(strcmp(hougen_name[i],"aichi")==0 || strcmp(hougen_name[i],"sizuoka11")==0 || strcmp(hougen_name[i],"sizuoka21")==0 || strcmp(hougen_name[i],"nagano2")==0 || strcmp(hougen_name[i],"nigata1")==0 || strcmp(hougen_name[i],"nigata2")==0 || strcmp(hougen_name[i],"toyama")==0 || strcmp(hougen_name[i],"gifu")==0 || strcmp(hougen_name[i],"isikawa1")==0 || strcmp(hougen_name[i],"yamanashi")==0 || strcmp(hougen_name[i],"nagano1")==0)
      gw.set_color(leaf[i],yellow);
    else if(strcmp(hougen_name[i],"kyoto")==0 || strcmp(hougen_name[i],"hyogo1")==0 || strcmp(hougen_name[i],"hyogo2")==0 || strcmp(hougen_name[i],"osaka")==0 || strcmp(hougen_name[i],"wakayama")==0 || strcmp(hougen_name[i],"nara")==0 || strcmp(hougen_name[i],"mie")==0)
      gw.set_color(leaf[i],pink);
    else if(strcmp(hougen_name[i],"hirosima1")==0 || strcmp(hougen_name[i],"simane")==0 || strcmp(hougen_name[i],"okayama")==0 || strcmp(hougen_name[i],"yamaguti")==0)
      gw.set_color(leaf[i],orange);
    else if(strcmp(hougen_name[i],"kouti1")==0 || strcmp(hougen_name[i],"kouti2")==0 || strcmp(hougen_name[i],"kagawa1")==0 || strcmp(hougen_name[i],"kagawa2")==0 || strcmp(hougen_name[i],"tokusima")==0 || strcmp(hougen_name[i],"ehime")==0)
      gw.set_color(leaf[i],violet);
    else if(strcmp(hougen_name[i],"fukuoka")==0 || strcmp(hougen_name[i],"saga")==0 || strcmp(hougen_name[i],"kumamoto1")==0 || strcmp(hougen_name[i],"kumamoto2")==0 || strcmp(hougen_name[i],"oita")==0 || strcmp(hougen_name[i],"miyazaki")==0 || strcmp(hougen_name[i],"nagasaki1")==0 || strcmp(hougen_name[i],"nagasaki2")==0 || strcmp(hougen_name[i],"kagosima")==0)
      gw.set_color(leaf[i],cyan);
    else if(strcmp(hougen_name[i],"nakijin")==0 || strcmp(hougen_name[i],"naha")==0)
      gw.set_color(leaf[i],ivory);

    gw.set_width(leaf[i],45);
    gw.set_height(leaf[i],15);
//**********************************ここまで*****************
	}

	node w;

      	forall_nodes(w,G){
		if(G.degree(w)==3){
	  		gw.set_color(w,green);
	  		gw.set_width(w,2);
	  		gw.set_height(w,2);
		}else{
	 		gw.set_shape(w,rectangle_node);
	  		gw.set_width(w,46);
	  		gw.set_height(w,13);
		}
      	}

	gw.open();
	gw.edit();
}
